---
title: ReadableStream.pipeThrough()
slug: Web/API/ReadableStream/pipeThrough
tags:
  - API
  - Experimental
  - Method
  - ReadableStream
  - Reference
  - Streams
  - pipeThrough
---
<div>{{SeeCompatTable}}{{APIRef("Streams")}}</div>

<p class="summary">The <strong><code>pipeThrough()</code></strong> method of the {{domxref("ReadableStream")}} interface provides a chainable way of piping the current stream through a transform stream or any other writable/readable pair.</p>

<p>Piping a stream will generally lock it for the duration of the pipe, preventing other readers from locking it.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>transformedStream</em> = <em>readableStream</em>.pipeThrough(<em>transformStream</em>[, <em>options</em>]);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>transformStream</dt>
 <dd>A {{domxref("TransformStream")}} (or an object with the structure <code>{writable, readable}</code>) consisting of a readable stream and a writable stream working together to transform some data from one form to another. Data writen to the <code>writable</code> stream can be read in some transformed state by the <code>readable</code> stream. For example, a {{domxref("TextDecoder")}}, has bytes written to it and strings read from it, while a video decoder has encoded bytes written to it and uncompressed video frames read from it.</dd>
 <dt>options {{optional_inline}}</dt>
 <dd>The options that should be used when piping to the <code>writable</code> stream. Available options are:
 <ol>
  <li><code>preventClose</code>: If this is set to <code>true</code>, the source <code>ReadableStream</code> closing will no longer cause the destination <code>WritableStream</code> to be closed. The method will return a fulfilled promise once this process completes, unless an error is encountered while closing the destination in which case it will be rejected with that error.</li>
  <li><code>preventAbort</code>: If this is set to <code>true</code>, errors in the source <code>ReadableStream</code> will no longer abort the destination <code>WritableStream</code>. The method will return a promise rejected with the source’s error, or with any error that occurs during aborting the destination.</li>
  <li><code>preventCancel</code>: If this is set to <code>true</code>, errors in the destination <code>WritableStream</code> will no longer cancel the source <code>ReadableStream</code>. In this case the method will return a promise rejected with the source’s error, or with any error that occurs during canceling the source. In addition, if the destination writable stream starts out closed or closing, the source readable stream will no longer be canceled. In this case the method will return a promise rejected with an error indicating piping to a closed stream failed, or with any error that occurs during canceling the source.</li>
  <li><code>signal</code>: If set to an <code><a href="/en-US/docs/Web/API/AbortSignal">AbortSignal</a></code> object, ongoing pipe operations can then be aborted via the corresponding <code><a href="/en-US/docs/Web/API/AbortController">AbortController</a></code>.</li>
 </ol>
 </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>The <code>readable</code> side of the <code>transformStream</code>.</p>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt>TypeError</dt>
 <dd>The <code>writable</code> and/or <code>readable</code> property of <code>transformStream</code> are undefined.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>In the following example (see <a href="https://mdn.github.io/dom-examples/streams/png-transform-stream/">Unpack chunks of a PNG</a> for the full code running live, and <a href="https://github.com/mdn/dom-examples/tree/master/streams/png-transform-stream">png-transform-stream</a> for the source code), an image is fetched and its body retrieved as a {{domxref("ReadableStream")}}. Next, we log the contents of the readable stream, use <code>pipeThrough()</code> to send it to a new function that creates a gray-scaled version of the stream, then log the new stream's contents too.</p>

<pre class="brush: js">// Fetch the original image
fetch('png-logo.png')
// Retrieve its body as ReadableStream
.then(response =&gt; response.body)
.then(rs =&gt; logReadableStream('Fetch Response Stream', rs))
// Create a gray-scaled PNG stream out of the original
.then(body =&gt; body.pipeThrough(new PNGTransformStream()))
.then(rs =&gt; logReadableStream('PNG Chunk Stream', rs))</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("Streams","#rs-pipe-through","pipeThrough()")}}</td>
   <td>{{Spec2('Streams')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div class="hidden">
<p>The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>
</div>

<p>{{Compat("api.ReadableStream.pipeThrough")}}</p>
